"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportEventQuestionnaireCancer(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "cancercaseLevelQuestions",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_12 import reports as reports_6_4_0

        return {
            "cancerGermlineVariantLevelQuestions": reports_6_4_0.CancerGermlineVariantLevelQuestions,
            "cancerSomaticVariantLevelQuestions": reports_6_4_0.CancerSomaticVariantLevelQuestions,
            "cancercaseLevelQuestions": reports_6_4_0.CancerCaseLevelQuestions,
            "otherActionableVariants": reports_6_4_0.AdditionalVariantsQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_12 import cva as cva_1_5_3
        from protocols.protocol_7_12 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.CancerGermlineVariantLevelQuestions": reports_6_4_0.CancerGermlineVariantLevelQuestions,
            "org.gel.models.report.avro.CancerSomaticVariantLevelQuestions": reports_6_4_0.CancerSomaticVariantLevelQuestions,
            "org.gel.models.report.avro.CancerCaseLevelQuestions": reports_6_4_0.CancerCaseLevelQuestions,
            "org.gel.models.report.avro.AdditionalVariantsQuestions": reports_6_4_0.AdditionalVariantsQuestions,
            "org.gel.models.cva.avro.ReportEventQuestionnaireCancer": cva_1_5_3.ReportEventQuestionnaireCancer,
        }

    __slots__ = [
        "cancercaseLevelQuestions",
        "additionalComments",
        "cancerGermlineVariantLevelQuestions",
        "cancerSomaticVariantLevelQuestions",
        "otherActionableVariants",
    ]

    def __init__(
        self,
        cancercaseLevelQuestions,
        additionalComments=None,
        cancerGermlineVariantLevelQuestions=None,
        cancerSomaticVariantLevelQuestions=None,
        otherActionableVariants=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.ReportEventQuestionnaireCancer model.

        :param cancercaseLevelQuestions:
            Cancer case level questions
        :type cancercaseLevelQuestions: CancerCaseLevelQuestions
        :param additionalComments:
            Please enter any additional comments you may have about the case here.
        :type additionalComments: None | str
        :param cancerGermlineVariantLevelQuestions:
            The variant group level questions for the cancer program
        :type cancerGermlineVariantLevelQuestions: None | CancerGermlineVariantLevelQuestions
        :param cancerSomaticVariantLevelQuestions:
            The somatic variant level questions for the cancer program
        :type cancerSomaticVariantLevelQuestions: None | CancerSomaticVariantLevelQuestions
        :param otherActionableVariants:
            Other actionable variants or entities. Please provide other
            (potentially) actionable entities: e.g domain 3 small
            variants, SV/CNV, mutational signatures, mutational burden
        :type otherActionableVariants: None | list[AdditionalVariantsQuestions]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
